<?php 
/***********************************************************************
 * YAC Module
 * SAM -  Simple Authentication Manager
 * YAC version 0-1-03b	> up
 *
 * Authentication mechanism for Yac CMS to allow user registration,
 * user login, user administration
 *
 * Copyright 2014 Jean-Marc LELIEVRE <yac-cms@yandex.com>
 * http://yac.wizekat.eu/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
***********************************************************************/
// SAM module usage example
/*
this is an example page:  http://your_yac_site.com/private
3 steps to setup:
STEP 1 create a page http://your_yac_site.com/private so you have a file named private in the folder your_yac_site/files
STEP 2 put this file (private.php) in the folder your_yac_site/php
STEP 3 ad your protected content below after the line : // PUT VALID USER CONTENT HERE
That's all folks !
*/

// check and load module
is_module_enabled('sam');
$localdir = str_replace("/php","",dirname(realpath(__FILE__)));
include("$localdir/modules/sam/system/init.php");


// set the protection using SAM_guard("page", "title");
SAM_guard("private", "Yac Private Section");


// PUT VALID USER CONTENT HERE
$c['content'].= "<h3>Private area</h3><p>This the user/password protected content.</p>";


// 4 The end ! add a logout link :
$c['content'].= $logout_link;




?>