<?php
/***********************************************************************
 * YAC - Yes, Another Cms !
 * version 0-1-04b	oct 2014
 *
 * Copyright 2014 Jean-Marc LELIEVRE <yac-cms@yandex.com>
 * http://yac.wizekat.eu/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
***********************************************************************/
function getUrl($url) {

$ch = curl_init($url);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_HEADER, 0);
$content = curl_exec($ch);
curl_close($ch);
return $content;
}
   function getRandomKey($len = 30) {
        mt_srand((double) microtime() * 1000000);
        for ($i = 1; $i <= $len; $i++) {
            $nRandom = mt_rand(1, 30);
            if ($nRandom <= 10) {
                // Uppercase letters
                $key .= chr(mt_rand(65, 90));
            } elseif ($nRandom <= 20) {
                $key .= mt_rand(0, 9);
            } else {
                // Lowercase letters
                $key .= chr(mt_rand(97, 122));
            }
        }
        return $key;
    }
    function getRandomNum($min, $max, $except) {
        //function returns a random integer between min and max, just like function rand() does.
        // Difference to rand is that the random generated number will not use any of the values
        // placed in $except. ($except must therefore be an array)
        // function returns false if $except holds all values between $min and $max.
        //first sort array values
        sort($except, SORT_NUMERIC);
        //calculate average gap between except-values
        $except_count = count($except);
        $avg_gap = ($max - $min + 1 - $except_count) / ($except_count + 1);
        if ($avg_gap <= 0)
            return false;
        //now add min and max to $except, so all gaps between $except-values can be calculated
        array_unshift($except, $min - 1);
        array_push($except, $max + 1);
        $except_count += 2;
        //iterate through all values of except. If gap between 2 values is higher than average gap,
        // create random in this gap
        for ($i = 1; $i < $except_count; $i++)
            if ($except[$i] - $except[$i - 1] - 1 >= $avg_gap)
                return mt_rand($except[$i - 1] + 1, $except[$i] - 1);
        return false;
    }

function sendEmail($to,$sujet,$message,$from="",$from_name="",$html=1) {
global $hostname;
$lang = SET_LANG;
  if ($from == "") {
  $from = SITE_EMAIL;
  }
  if ($from_name == "") {
  $from_name = SITE_NAME;
  }
$headers = "";
  if ($html == 1) {
  // message
  $message = '
  <html>
  <head>
  <title>'.$sujet.'</title>
  </head>
  <body>
  <h3>'.$sujet.'</h3>
  <p>'.nl2br($message).'</p>
  <p>
  &nbsp;
  </p>

  <address>
  <ul>
  <li>'.$c['output']["$lang"]['sendemail']['received'].': <a href="http:'.$hostname.'">http:'.$hostname.'</a></li>
  <li>IP: '.$_SERVER['REMOTE_ADDR'].'</li>
  <li>Date: '.date("d/m/Y H:i:s").'</li>
  </ul>
  </address>
  </body>
  </html>
  ';
  // To send HTML mail, the Content-type header must be set
  $headers  = 'MIME-Version: 1.0' . "\r\n";
  $headers .= 'Content-type: text/html; charset=iso-8859-1' . "\r\n";
  }
  else {
  $message.= "\n".$c['output']["$lang"]['sendemail']['received']." http:$hostname\nIP: $_SERVER[REMOTE_ADDR]\n".'Date: '.date("d/m/Y H:i:s")."\n";
  }
$headers .= 'From: '.$from_name.' <'.$from.'>' . "\r\n";
//$headers .= 'Cc: birthdayarchive@example.com' . "\r\n";
//$headers .= 'Bcc: birthdaycheck@example.com' . "\r\n";
// Mail it
mail($to, $sujet, $message, $headers);
}


function getModulesHeaders($module="") {
$localdir = str_replace("/system","",dirname(realpath(__FILE__)));

  if (file_exists("$localdir/modules")) {
  // modules
  $rep=opendir("$localdir/modules");
  while ($file = readdir($rep)){
  $file = trim(chop($file));
    if ($file != "." && $file != ".." && $file != "_disabled") {   
      if (file_exists("$localdir/modules/$file/css")) {
        if ($file == $module) {
	$css=opendir("$localdir/modules/$file/css");
	  while ($style = readdir($css)) {
	  $style = trim(chop($style));
	    if ($style != "." && $style != ".." && strstr($style,".css")) {
	    echo "\n\t<link rel='stylesheet' href='modules/$file/css/$style'>";
	    }
	  }
	closedir($css); 
	}
      }
      if (file_exists("$localdir/modules/$file/js")) {
      $js=opendir("$localdir/modules/$file/js");
	while ($script = readdir($js)) {
	$script = trim(chop($script));
	  if ($script != "." && $script != ".." && strstr($script,".js")) {
	  echo "\n\t<script src='modules/$file/js/$script'></script>";
	  }
	}
	closedir($js);
      }
    }
  }
}
}
function getHeaders() {
global $c,$hostname;
echo "\n\t<title>".$c['title']." - ".$c['page']."</title>";
echo "\n\t<meta name='description' content=\"".$c['description']."\">";
echo "\n\t<meta name='keywords' content='".$c['keywords']."'>";
echo "\n\t<script type='text/javascript' src='//ajax.googleapis.com/ajax/libs/jquery/1.11.0/jquery.min.js'></script>\n\t<meta charset='utf-8'>";
echo "\n\t<base href='$hostname'>";
echo "\n\t<link rel='stylesheet' href='css/local.css'>";
echo "\n\t<script src='".$hostname."js/local.js'></script>";

  if (isset($c['addcss'])) {
    if (strstr($c['addcss'],"|")) {
    $more_css = explode("|",$c['addcss']);
      foreach($more_css as $css) {
      echo "\n\t<link rel='stylesheet' href='".$css."'>\n";
      }
    }
    else {
    echo "\n\t<link rel='stylesheet' href='".$c['addcss']."'>\n";
    }
  }
  if (isset($c['addjssrc']) || isset($c['addjscontent'])) {
    if (strstr($c['addjssrc'],"|")) {
    $more_js = explode("|",$c['addjssrc']);
      foreach($more_js as $js) {
      echo "\n<script type='text/javascript' src='".$js."'></script>\n";
      }
    }
    else {
    echo "\n<script type='text/javascript'";
      if (isset($c['addjssrc'])) {
      echo " src='".$c['addjssrc']."'";
      }
    echo ">\n";
      if (isset($c['addjscontent'])) {
      echo $c['addjscontent'];
      }
    echo "\n</script>\n";
    }
  }
}
function loadPlugins(){
	global $hook,$c;
	$cwd = getcwd();
	if(chdir("./plugins/")){
		$dirs = glob('*', GLOB_ONLYDIR);
		if(is_array($dirs))foreach($dirs as $dir){
			require_once($cwd.'/plugins/'.$dir.'/index.php');
		}
	}
	chdir($cwd);
	$hook['admin-head'][] = "<script type='text/javascript' src='./js/editInplace.php?hook=".$hook['admin-richText']."'></script>";
}

function getSlug($p){
	$p = strip_tags($p);
	preg_match_all('/([a-z0-9A-Z-_]+)/', $p, $matches);
	$matches = array_map('strtolower', $matches[0]);
	$slug = implode('-', $matches);
	return $slug;
}
function is_admin(){
	global $c;
	if(isset($_SESSION['l']) and $_SESSION['l']==$c['password']) {
	$c['loggedin'] = true;
	return true;
	}
	else {
	return false;
	}
}

function is_loggedin(){
	global $c;
	return $c['loggedin'];
}

function editTags(){
	global $hook;
	if(!is_loggedin() && !isset($_REQUEST['login'])) return;
	foreach($hook['admin-head'] as $o){
		echo "\t".$o."\n";
	}
}

function content($id,$content){
	global $d,$content1;
	$edt = explode("<!--noedit-->", $content);
	$content1 = $edt[0];
	$content2 = $content;
	echo (is_loggedin())? "<span title='".$d['default']['content']."' id='".$id."' class='editText richText'>".$content1."</span> ".$edt[1]: $content2;
}

function menu($stags,$etags,$noadmin=0){
	global $c,$hostname,$rp;
	$lang = SET_LANG;
	$mlist = explode('<br />',$c['menu']);
	for($i=0;$i<count($mlist);$i++){
		$page = getSlug($mlist[$i]);
		if(!$page) continue;
		$class = "";
		if ("$page/" == "$rp" || $page == $rp) {
		$class = " class='current'";
		}
		echo str_replace("li", "li$class",$stags)." tile='$page' href='".$hostname.$page."'>".str_replace('-',' ',$page)." ".$etags." \n";
	}
	if ($class != "") {
	$class.= " adminlink";
	}
	elseif (strstr($_SERVER['REQUEST_URI'], "?login")) {
	$class = " class='current adminlink'";
	}
	else {
	$class = " class='adminlink'";
	}
	if ($noadmin == 0) {
	  if (is_loggedin()) {
	  echo str_replace("li", "li$class",$stags)." tile='".$c['output']["$lang"]['menu']['logout']."' href='?logout'><img src='images/admin342b.png'>".$etags." \n";
	  }
	  else {
	  echo str_replace("li", "li$class",$stags)." tile='".$c['output']["$lang"]['menu']['login']."' href='?login'><img src='images/admin342b.png'>".$etags." \n";
	  }
	}
}
function sub_menu($stags,$etags){
	global $c,$hostname;
	$localdir = str_replace("system","files",realpath(dirname(__FILE__)));
	
	$mlist = explode('<br />',$c['menu']);
	for($i=0;$i<count($mlist);$i++){
		$page = getSlug($mlist[$i]);
		  if (file_exists("$localdir/$page.submenu")) {
		  $sub = file_get_contents("$localdir/$page.submenu");
		  $mlist2 = explode('<br />',$sub);
		  $submenu = "<ul>";
		    for($i=0;$i<count($mlist2);$i++){
		    $page2 = getSlug($mlist2[$i]);
		    $submenu.= $stags." href='".$hostname.$page2."'>".str_replace('-',' ',$page2)." ".$etags." \n";
		    }
		  $submenu.= "</ul>";
		  }
		if(!$page) continue;
		echo $stags." href='".$hostname.$page."'>".str_replace('-',' ',$page)." ".str_replace("</a>", "</a>$submenu",$etags)." \n";
	}
}
function setLang() {
$rootdir = str_replace("/system","",dirname(realpath(__FILE__)));  
  if (isset($_SESSION['lang']) && file_exists("$rootdir/lang/".$_SESSION['lang']."/lang.php")) {
  $rep=opendir("$rootdir/lang/");
    while ($file = readdir($rep)){
    $file = trim(chop($file));
      if ($file != "." && $file != ".." && $file != "") {   
      echo "<b><a href='?set_lang=$file'>$file</a></b> ";
      }
    }
  }
}
function loginForm(){
global $c, $msg;
$msg = '';
$lang = SET_LANG;
	if(isset($_POST['sub'])) login();
	$c['content'] = "<h2>".$c['output']["$lang"]['loginform']['header']."</h2><br><br><div ><form action='' method='POST'>
	".$c['output']["$lang"]['loginform']['password']." <input type='password' name='password'>
	<input type='submit' name='login' value='Login'> $msg
	<br /><br /><b class='toggle'>".$c['output']["$lang"]['loginform']['toggle']."</b>
	<div class='hide'><br />".$c['output']["$lang"]['loginform']['hide']."<br />
	".$c['output']["$lang"]['loginform']['new']." <input type='password' name='new'>
	<input type='submit' name='login' value='".$c['output']["$lang"]['loginform']['change']."'>
	<input type='hidden' name='sub' value='sub'>
	</div>
	</form></div>";
}

function login(){
	global $c, $msg;
	$lang = SET_LANG;
	if(md5($_POST['password'])<>$c['password']){
		$msg = $c['output']["$lang"]['login']['wrong'];
		return;
	}
	if($_POST['new']){
		savePassword($_POST['new']);
		$msg = $c['output']["$lang"]['login']['changed'];
		return;
	}
	$_SESSION['l'] = $c['password'];
	$_SESSION['Yac_as'] = YAC_SESSION;
	header('Location: ./');
	exit;
}

function savePassword($p){
$lang = SET_LANG;
	$file = @fopen('files/password', 'w');
	if(!$file){
		echo $c['output']["$lang"]['savepassword']['error'];
		exit;
	}
	fwrite($file, md5($p));
	fclose($file);
	return md5($p);
}
function new_version() {
global $archive;
  if (defined("YAC_VERSION_CHK_URL")) {
  $url = YAC_VERSION_CHK_URL;
    if (defined("YAC_VERSION")) {
    $ver = @getUrl($url);
      if (trim(chop($ver)) != YAC_VERSION) {
      $upurl = trim(chop($ver));
      $nv = file_get_contents($upurl);
      $info = file_get_contents(str_replace("zip","info",$upurl));
      $name = str_replace("http://yac.wizekat.eu/releases/","",$upurl);
      $nameinfo = str_replace("zip","info", $name);
      define("ARCHIVE", $name);
	if (!file_exists(realpath(dirname(__FILE__))."/updates")) {
	mkdir(realpath(dirname(__FILE__))."/updates");
	chmod(realpath(dirname(__FILE__))."/updates", 0777);
	}

      if (!file_exists(realpath(dirname(__FILE__))."/updates/$name")) {
	file_put_contents(realpath(dirname(__FILE__))."/updates/$name",$nv);
	file_put_contents(realpath(dirname(__FILE__))."/updates/$nameinfo",$info);
	chmod(realpath(dirname(__FILE__))."/updates/$name", 0777);
	return true;
	}
      }
    }
    else {
    return false;
    }
  }
  else {
  return false;
  }
}
function autoupdate() {
// backup folders
$path = realpath(dirname(__FILE__));
$pathbak = realpath(dirname(__FILE__))."/updates/backup";
$rootpath = str_replace("/system","",$path);

$rep=opendir("$path");
  while ($file = readdir($rep)){
  $file = trim(chop($file));
  $ext = substr($file,-3);
  $len = strlen($file) - 4;
    if ($file != "." && $file != ".." && $file != "" && !is_dir("$path/$file")) {   
    $bak = file_get_contents("$path/$file");
    file_put_contents("$pathbak/system/$file",$bak);    
    }
    elseif (is_dir("$path/$file") && $file != "." && $file != ".." && $file !="updates") {
    $rep2=opendir("$path/$file");
      while ($file2 = readdir($rep2)) {
      $file2 = trim(chop($file2));
	if ($file2 != "." && $file2 != ".." && $file2 != "" && !is_dir("$path/$file/$file2")) {   
	$bak2 = file_get_contents("$path/$file/$file2");
	  if (!file_exists("$pathbak/system/$file")) {
	  mkdir("$pathbak/system/$file");
	  chmod("$pathbak/system/$file", 0777);  
	  }
	file_put_contents("$pathbak/system/$file/$file2",$bak2);    
	}     
      }
    closedir($rep2);
    }
  }
closedir($rep);

$rep=opendir("$rootpath/js");
  while ($file = readdir($rep)){
  $file = trim(chop($file));
  $ext = substr($file,-3);
  $len = strlen($file) - 4;
    if ($file != "." && $file != ".." && $file != "" && !is_dir("$rootpath/js/$file")) {   
    $bak = file_get_contents("$rootpath/js/$file");
    file_put_contents("$pathbak/js/$file",$bak);    
    }
  }
closedir($rep);

$rep=opendir("$rootpath/css");
  while ($file = readdir($rep)){
  $file = trim(chop($file));
  $ext = substr($file,-3);
  $len = strlen($file) - 4;
    if ($file != "." && $file != ".." && $file != "" && !is_dir("$rootpath/css/$file")) {   
    $bak = file_get_contents("$rootpath/css/$file");
    file_put_contents("$pathbak/css/$file",$bak);    
    }
  }
closedir($rep);

$rep=opendir("$rootpath");
  while ($file = readdir($rep)){
  $file = trim(chop($file));
  $ext = substr($file,-3);
  $len = strlen($file) - 4;
    if ($file != "." && $file != ".." && $file != "" && !is_dir("$rootpath/$file")) {   
    $bak = file_get_contents("$rootpath/$file");
    file_put_contents("$pathbak/$file",$bak);    
    }
  }
closedir($rep);

$rep=opendir("$rootpath/files");
  while ($file = readdir($rep)){
  $file = trim(chop($file));
  $ext = substr($file,-3);
  $len = strlen($file) - 4;
    if ($file != "." && $file != ".." && $file != "" && !is_dir("$rootpath/$file")) {   
    $bak = file_get_contents("$rootpath/files/$file");
    file_put_contents("$pathbak/files/$file",$bak);    
    }
  }
closedir($rep);

$rep=opendir("$rootpath/php");
  while ($file = readdir($rep)){
  $file = trim(chop($file));
  $ext = substr($file,-3);
  $len = strlen($file) - 4;
    if ($file != "." && $file != ".." && $file != "" && !is_dir("$rootpath/$file")) {   
    $bak = file_get_contents("$rootpath/php/$file");
    file_put_contents("$pathbak/php/$file",$bak);    
    }
  }
closedir($rep);
$newver = $path."/updates/".ARCHIVE;
$dir = str_replace(".zip","",ARCHIVE);
//exec("unzip $newver");
/*
require_once('pclzip.lib.php');
  $archive = new PclZip($newver);
  
  if ($archive->extract(PCLZIP_OPT_PATH, "$path/updates") == 0) {
    die("Error : ".$archive->errorInfo(true));
  }
*/

/*
mkdir("$path/updates/$dir");
chmod("$path/updates/$dir", 0777);  

require_once dirname(__FILE__)."/dUnzip2.inc.php";
require_once dirname(__FILE__)."/dZip.inc.php";
$zip = new dUnzip2($archive);
$zip->getList();
$zip->unzipAll("$path/updates");
*/




/*
$zip = new ZipArchive;
if ($zip->open("$archive") === TRUE) {
    $zip->extractTo("$path/updates");
    $zip->close();
    }
chmod("$path/updates/$dir", 0777);  
chown("$path/updates/$dir", 10039); 
if ($zip->open("$archive") === TRUE) {
    $zip->extractTo("$path/updates");
    $zip->close();
    }
    */
}
function settings() {
	global $c,$d;
	$lang = SET_LANG;
	$barname = $c['output']["$lang"]['settings']['barname'];
	if (new_version()) {
	$newver = "New version released";
	autoupdate();
	}
	echo "<div class='settings'>
	<h3 class='toggle'>↕ ".$barname." ↕</h3>
	<div class='hide'><b>$newver</b>
	<div class='change border'><b>".$c['output']["fr"]['settings']['theme']."</b>:&nbsp;<span id='themeSelect'><select name='themeSelect' onchange='fieldSave(\"themeSelect\",this.value);'>";
	if(chdir("./themes/")){
		$dirs = glob('*', GLOB_ONLYDIR);
		foreach($dirs as $val){
			$select = ($val == $c['themeSelect'])? ' selected' : ''; 
			echo '<option value="'.$val.'"'.$select.'>'.$val."</option>\n";
		}
	}
	echo "</select></span></div>
	<div class='change border'><b>".$c['output']["$lang"]['settings']['navigationhdr']."</b><address>".$c['output']["$lang"]['settings']['navigation']."</address><br /><span id='menu' title='Home' class='editText'>".$c['menu']."</span></div>";
	foreach(array('title','description','keywords','copyright') as $key){
		echo "<div class='change border'><b>".ucfirst($key)."</b>:&nbsp;<span title='".$d['default'][$key]."' id='".$key."' class='editText'>".$c[$key]."</span></div>";
	}
	
	$localdir = str_replace("/system","",dirname(realpath(__FILE__)));
	$htm = "";
	if (file_exists("$localdir/modules")) {
	  if (file_exists("$localdir/system/conf/modules.conf")) {
	  $module_conf = @file_get_contents("$localdir/system/conf/modules.conf");
	  $mconf = explode("\n",$module_conf);
	    foreach($mconf as $conf) {
	    $md = explode(":",$conf);
	    $module['name'] = $md[0];
	    $module["$md[0]"] = $md[1];    
	    }
	  }
	  




	$htm.= "<div class='change border'><b>".$c['output']["$lang"]['settings']['modules']."</b><br />";
	$rep=opendir("$localdir/modules");
	  while ($file = readdir($rep)){
	  $file = trim(chop($file));
	    if ($file != "." && $file != ".." && $file != "_disabled" && is_dir("$localdir/modules/$file")) {   
	    $activate = "<a class='right' href='?activate_mod=$file'>".$c['output']["$lang"]['settings']['enable']."</a>";
	    $desactivate = "<a class='right' href='?desactivate_mod=$file'>".$c['output']["$lang"]['settings']['disable']."</a>";
	    $admin_link = "";
	      if (file_exists("$localdir/modules/$file/admin.php")) {
	      $admin_link = "<a class='right' href='modules/$file/admin.php'>".$c['output']["$lang"]['settings']['moduleadmin']."</a>";
	      }
	      elseif (file_exists("$localdir/modules/$file/admin/index.php")) {
	      $admin_link = "<a class='right' href='modules/$file/admin/index.php'>".$c['output']["$lang"]['settings']['moduleadmin']."</a>";
	      }
	    $status =  $module["$file"];
	    $name = "&lt;".ucfirst($file)."&gt;";
	      if ($status == 'enabled') {
	      $link = $desactivate;
	      }
	      else {
	      $status = 'disabled';
	      $link = $activate;
	      $name = "<span style='color:gray;'>$name</span>";
	      }
	    $module["$file"] = $status;
	    $htm.= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b>$name</b> : $link &nbsp; &nbsp; &nbsp; &nbsp; $admin_link <br />";
	    }
	  }
	  foreach($module as $name=>$value) {
	    if ($name != "" && $value != "") {
	    $newconf.= trim(chop($name)).":".trim(chop($value))."\n";
	    }
	  }
	$config = fopen("$localdir/system/conf/modules.conf", "w");
	fwrite($config, $newconf);
	fclose($config);

	$htm.= "</div>";
	}
    echo $htm;
    echo "</div></div>";
}

function is_module_enabled($mod) {
global $c, $rp,$hostname;
$localdir = str_replace("/system","",dirname(realpath(__FILE__)));
  if (file_exists("$localdir/modules")) {
    if (file_exists("$localdir/system/conf/modules.conf")) {
    $module_conf = @file_get_contents("$localdir/system/conf/modules.conf");
    $mconf = explode("\n",$module_conf);
      foreach($mconf as $conf) {
      $md = explode(":",$conf);
      	if ($md[0] == $mod && $md[1] == 'enabled') {
      	return true;
      	}
      }
    }
  }
include("$localdir/system/module-not-loaded.php");
exit;
}

$rootdir = str_replace("/system","",dirname(realpath(__FILE__)));  
  if(!defined("YAC_VERSION")) {
  include("$rootdir/system/conf/version.php");
  }
  if ($_GET['set_lang'] != "") {
    if (file_exists("$rootdir/lang/".trim(chop($_GET['set_lang']))."/lang.php")) {
    $_SESSION['lang'] = trim(chop($_GET['set_lang']));
    $_SERVER['REQUEST_URI'] = str_replace("?set_lang=$_GET[set_lang]","", $_SERVER['REQUEST_URI']);
    }
  }

?> 
